// BoundingBox.h: interface for the BoundingBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(BOUNDINGBOX_H)
#define BOUNDINGBOX_H


#include "RULES_Vector.h"	// Added by ClassView
#ifdef WIN32
#include <windows.h>
#endif
#include <GL\gl.h>
#include <GL/glut.h>

/**
* Classe permettant de reprsent une bounding box. En fait, c'est une AABB.
*/
class BoundingBox  
{
public:

	/**
	* Affichage de la boundingbox en filaire
	*/
	void debug();

	/**
	* Affecte la position du centre de la boundingbox
	*
	* @param center la position du centre
	* @param haut haut
	* @param larg larg
	* @param prof prof
	*/
	void setAttributs(RULES_Vector center,float haut,float larg,float prof);

	/**
	* Affecte la profondeur de la boundingbox
	*
	* @param la profondeur
	*/
	void setProfondeur(float prof);
	/**
	* Affecte la largeur de la bounding box
	*
	* @param la largeur
	*/
	void setLargeur(float larg);
	/**
	* Affecte la hauteur de la boundingbox
	*
	* @param la hauteur
	*/
	void setHauteur(float haut);
	/**
	* Affecte la position du centre de la boundingbox
	*
	* @param la position du centre
	*/
	void setCentre(RULES_Vector center);

	/**
	* Rcupere la hauteur de la boundingbox
	*
	* @return la hauteur
	*/
	float getProfondeur();
	/**
	* Rcupere la largeur de la boundingbox
	*
	* @return la largeur
	*/
	float getLargeur();
	/**
	* Rcupere la profondeur de la bounding box
	*
	* @return la profondeur
	*/
	float getHauteur();
	/**
	* Rcupere la position du centre de la boundingbox
	*
	* @return la position du centre
	*/
	RULES_Vector getCentre();

	/**
	* Constructeur
	*/
	BoundingBox();
	/**
	*Destructeur
	*/
	virtual ~BoundingBox();

private:
	/**
	* La position du centre de la boundingbox
	*/
	RULES_Vector centre;
	/**
	* la hauteur de la boundingbox
	*/
	float hauteur;
	/**
	* la largeur de la boundingbox
	*/
	float largeur;
	/**
	* la profondeur de la bounding box
	*/
	float profondeur;
};

#endif 
