// EndMenu.cpp: implementation of the EndMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "EndMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EndGLUTMenu::EndGLUTMenu()
{
	killedLoutre = 0;
	this->image = new RULES_Texture();
	image->loadBMP("./ressources/textures/sol.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_REPEAT,GL_REPEAT,0,false,192,192,192,0,1);
}

EndGLUTMenu::~EndGLUTMenu()
{
	if (image != NULL)
	{
		delete this->image ;
		image = NULL;
	}
}

void EndGLUTMenu::draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	gluLookAt(0,100,100,0,0,0,0,1,0);
	// affiche un rectangle de test
	// on desactive le depth test
	glDisable(GL_DEPTH_TEST);
	// on passe en mode projection
	glMatrixMode(GL_PROJECTION);
		
				// on sauvegarde la matrice de projection
	glPushMatrix();
	
		// on nettoie la matrice de projection
		glLoadIdentity();
		
		// on passe en mode ortho de la taille de l'ecran
		glOrtho(0,1024,0,768,-1,1);	
		
		// on passe en mode modelview
		glMatrixMode(GL_MODELVIEW);
		
		// on sauvegarde la matrice de modelview
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, this->image->getId());
			glBegin(GL_QUADS);
				glTexCoord2f(0,0);
				glVertex3f(0,0,0);
				glTexCoord2f(1,0);
				glVertex3f(1024,0,0);
				glTexCoord2f(1,1);
				glVertex3f(1024,768,0);
				glTexCoord2f(0,1);
				glVertex3f(0,768,0);
			glEnd();

			glMatrixMode(GL_PROJECTION);
		
		// et on recupere la matrice de projection sauvegard precedement
		glPopMatrix();	
		
		// on selectionne la matrice de projection modelview
		glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	// on desactive le depth test
	glEnable(GL_DEPTH_TEST);

	Font * font = MainMenu::getInstance()->getFont();
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_SRC_ALPHA);
	font->setScreenSize(640*0.66,480*0.66);// la bidouille ...
	font->glText2d(220*0.3125,390*0.3125,"Score           : %d",this->score);
	font->glText2d(220*0.3125,330*0.3125,"Loutre detruite : %d",this->killedLoutre);
	font->glText2d(220*0.3125,270*0.3125,"Precision       : %d %%",this->accuracy);
	switch(Game::getGame()->getDifficulty())
	{
	case 5:
		font->glText2d(220*0.3125,450*0.3125,"Difficulte      : Trop facile");
		break;
	case 8:
		font->glText2d(220*0.3125,450*0.3125,"Difficulte      : Facile");
		break;
	case 11:
		font->glText2d(220*0.3125,450*0.3125,"Difficulte      : Normale");
		break;
	case 14:
		font->glText2d(220*0.3125,450*0.3125,"Difficulte      : Difficile");
		break;
	case 17:
		font->glText2d(220*0.3125,450*0.3125,"Difficulte      : Tres difficile");
		break;
	case 20:
		font->glText2d(220*0.3125,450*0.3125,"Difficulte      : Impossible");
		break;
	}
	font->setScreenSize(800,600);// la bidouille ...
	font->glText2d(0,700*0.78,"echape pour retourner au menu");
	glDisable(GL_BLEND);

	RULES_Vector pos;
	pos.setCoord(mouseX,768-mouseY,0);
	ParticleEngine::getInstance()->frame(&pos);
	Mouse::getInstance()->draw(&pos);

	glFlush();
	glutSwapBuffers();
	// on lui fait charger la partie

}


void EndGLUTMenu::idle(void)
{
	// on charge le sound manager et on verifie le son
	SoundManager::getInstance()->checkSound();
	glutPostRedisplay();

}


void EndGLUTMenu::mouseClicked(int boutton,int etat,int x,int y)
{
	if (etat == GLUT_DOWN)
	{
		SoundManager::getInstance()->playClic();
	}
}

void EndGLUTMenu::mouseMoved(int x,int y)
{
	mouseX = x;
	mouseY = y;
}

void EndGLUTMenu::mouseMovedClicked(int x,int y)
{

}


void EndGLUTMenu::keyPressed(unsigned char key,int x,int y)
{
	if (key == 27)
	{
		glViewport(0,0,1024,768);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluPerspective(90,1024/768,1,10000);
		glMatrixMode(GL_MODELVIEW);
		GLUT * main = MainMenu::getInstance();
		*(this->currentGlut) = main; 
		main->setCurrentGlut(this->currentGlut);
	}
}

void EndGLUTMenu::keyReleased(unsigned char key,int x,int y)
{

}


void EndGLUTMenu::reshape(int largeur,int hauteur)
{
	glViewport(0,0,(GLsizei) largeur,(GLsizei) hauteur);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,largeur/hauteur,1,10000);
	glMatrixMode(GL_MODELVIEW);

}


void EndGLUTMenu::setScore(int sco)
{
	this->score = sco;
}

void EndGLUTMenu::setKilledLoutre(int kl)
{
	killedLoutre = kl;
}

void EndGLUTMenu::setAccuracy(int accur)
{
	this->accuracy = accur;
}
