// EndMenu.h: interface for the EndMenu class.
//
//////////////////////////////////////////////////////////////////////

#ifndef ENDMENU_H
#define ENDMENU_H

#include "Menu.h"
#include "MainMenu.h"
#include "ParticleEngine.h"
#include "mouse.h"
#include "SoundManager.h"

/**
 * classe gerant le menu affich a la fin d'une partie.
 *
 * /!\ Classe renomme de EndMenu => EndGLUTMenu car VC++7.0 a deja un objet nomm EndMenu, ce qui entraine des
 * problemes de nom...
 * pour plus de renseignement sur les methode de cette classe, voir la classe GLUT
 */
class EndGLUTMenu : public Menu  
{
private:
	int accuracy;
	int score;
	EndGLUTMenu();
	int mouseX,mouseY;
	int killedLoutre;
public:
	void setAccuracy(int accur);
	void setKilledLoutre(int kl);
	void setScore(int sco);
	virtual ~EndGLUTMenu();
	static EndGLUTMenu * getInstance(){static EndGLUTMenu instance; return &instance;};

	void draw(void);

	void idle(void);

	void mouseClicked(int boutton,int etat,int x,int y);
	void mouseMoved(int x,int y);
	void mouseMovedClicked(int x,int y);

	void keyPressed(unsigned char key,int x,int y);
	void keyReleased(unsigned char key,int x,int y);
	void specialKeyFunc(int key,int x,int y){};
	void specialKeyUpFunc(int key,int x,int y){};

	void reshape(int largeur,int hauteur);
};

#endif 