
#include "EnhancedRender.h"

EnhancedRender::EnhancedRender()
{
	this->lightPos = new RULES_Vector();
	this->texSkinID = 0;
	this->texToonDiffuseID = 0;

	//init pour optimisation, affichage
	this->lastNumberOfToonTexCoord=0;
	this->diffuseToonTexCoord = 0;
}

EnhancedRender::~EnhancedRender()
{
	delete lightPos;
	delete [] diffuseToonTexCoord;
}


void EnhancedRender::draw(Model *model,RULES_Vector modelPos)
{
	//***********************
	//*     pr-calcul      *
	//***********************

	//*** acquisition des donne ncessaire pour calcul
	ModelVertex *vertexPos = model->getVertex();
//	RULES_Vector *vertexNormal = model->getNormalV();
	int nbVertex=model->getVertexNumber();
	
	//update du tableau de coordonne de texture toon si celuici est devenu trop petit
	if( lastNumberOfToonTexCoord<nbVertex )
	{
		delete [] diffuseToonTexCoord;
		diffuseToonTexCoord = new float[nbVertex*2];	//nbVertex*1 car texture1D
	}

	//*** translation de la lumire par rapport au model
	//c'est fait en dehors
	RULES_Vector finalLight = modelPos;

	//*** calcul des coordonne de texture1D pour couleur diffuse pour chaque vertex
	float *tmp=diffuseToonTexCoord;
	RULES_Vector *t;
	for(int i=0 ; i<nbVertex ; i++)
	{
		//calcul du vecteur allant du vertex  la lumire
		t=&((finalLight - (vertexPos->vertex)));
		t->normalisation();
		//calcul du dot3 entre t et la normal
		*tmp = t->dot3(&vertexPos->normal);

		//incrmentation de boucle
		tmp++;
		*tmp = 0;
		tmp++;
		vertexPos++;
	}



	//***********************
	//*     rendu Toon      *
	//***********************

	//*** activation des tableaux de coordonne
	glEnableClientState(GL_VERTEX_ARRAY);
	glVertexPointer(3,GL_FLOAT,sizeof(ModelVertex),model->getVertex()->vertex.getCoord());


	glActiveTextureARB(GL_TEXTURE1_ARB);
	glEnable(GL_TEXTURE_2D);
	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	glBindTexture(GL_TEXTURE_2D,model->getTexture()->getId());

	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_TEXTURE_2D);
	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
	glBindTexture(GL_TEXTURE_2D,this->getTexToonDiffuseID());

	glClientActiveTextureARB(GL_TEXTURE1_ARB);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glTexCoordPointer(2,GL_FLOAT,sizeof(ModelVertex),model->getVertex()->texCoord);

	glClientActiveTextureARB(GL_TEXTURE0_ARB);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glTexCoordPointer(2,GL_FLOAT,0,diffuseToonTexCoord);


	glEnable(GL_CULL_FACE);
	glCullFace(GL_BACK);										//cull des faces arrire

	//*** affichage model
	glDrawArrays(GL_TRIANGLES,0,model->getVertexNumber());

	//***********************
	//*   rendu silhouette  *
	//***********************

	//*** prparation affichage
	glFrontFace(GL_CCW);
	glCullFace(GL_FRONT);//cull des faces avant
	glDepthFunc(GL_LESS);
	glPolygonMode(GL_BACK,GL_LINE);
	glPolygonMode(GL_FRONT,GL_LINE);

	glClientActiveTextureARB(GL_TEXTURE1_ARB);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	glClientActiveTextureARB(GL_TEXTURE0_ARB);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);

	glActiveTextureARB(GL_TEXTURE1_ARB);
	glDisable(GL_TEXTURE_2D);
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glDisable(GL_TEXTURE_2D);

	//face arrire en ligne
	glLineWidth(3);

	//*** affichage model
	glColor3f(0,0,0);
	glDrawArrays(GL_TRIANGLES,0,model->getVertexNumber());
	glColor3f(0.8,0.8,0.8);

	//********** on dsactive tout **********
	//dsactivation des tableaux de coordonne de vertices
	glDisableClientState(GL_VERTEX_ARRAY);
	//dsactivation culling
	glDisable(GL_CULL_FACE);
	//face arrire pleine
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_TEXTURE_2D);

	glDepthFunc(GL_LEQUAL);
	glPolygonMode(GL_BACK,GL_FILL);
	glPolygonMode(GL_FRONT,GL_FILL);
}


void EnhancedRender::drawToonOnly( Model *model, RULES_Vector modelPos,bool silhouette)
{
	//***********************
	//*     pr-calcul      *
	//***********************

	//*** acquisition des donne ncessaire pour calcul
	ModelVertex *vertexPos = model->getVertex();
	int nbVertex=model->getVertexNumber();

	//update du tableau de coordonne de texture toon si celuici est devenu trop petit
	if( lastNumberOfToonTexCoord<nbVertex )
	{
		delete [] diffuseToonTexCoord;
		diffuseToonTexCoord = new float[nbVertex*2];	//nbVertex*1 car texture1D
	}

	//*** translation de la lumire par rapport au model
	//c'est fait en dehors
	RULES_Vector finalLight = modelPos;

	//*** calcul des coordonne de texture1D pour couleur diffuse pour chaque vertex
	float *tmp=diffuseToonTexCoord;
	RULES_Vector *t;
	for(int i=0 ; i<nbVertex ; i++)
	{
		//calcul du vecteur allant du vertex  la lumire
		t=&((finalLight - (vertexPos->vertex)));
		t->normalisation();
		//calcul du dot3 entre t et la normal
		*tmp = t->dot3(&vertexPos->normal);

		//incrmentation de boucle
		tmp++;
		*tmp = 0;
		tmp++;
		vertexPos++;
	}


	//***********************
	//*     rendu Toon      *
	//***********************

	//*** activation des tableaux de coordonne
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);

	//********** 1re pass **********
	//*** assignation coordonne des vertex et texture du toon
	glVertexPointer(3,GL_FLOAT,sizeof(ModelVertex),model->getVertex()->vertex.getCoord());			//TODO rajouter un stride car coord de skin sont dedans
	glTexCoordPointer(2,GL_FLOAT,0,diffuseToonTexCoord);

	//*** prparation affichage
	glEnable(GL_CULL_FACE);										//culling activ
	glCullFace(GL_BACK);										//cull des faces arrire
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,this->getTexToonDiffuseID());	//bind texture de toon
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);

	//*** affichage model
	glDrawArrays(GL_TRIANGLES,0,model->getVertexNumber());
	
	
	//***********************
	//*   rendu silhouette  *
	//***********************
	if(silhouette)
	{
		//*** prparation affichage
		glCullFace(GL_FRONT);										//cull des faces avant

		glDisable(GL_TEXTURE_2D);

		//face arrire en ligne
		glPolygonMode(GL_BACK,GL_LINE);
		glLineWidth(3);

		//*** affichage model
		glColor3f(0,0,0);
		glDrawArrays(GL_TRIANGLES,0,model->getVertexNumber());

		//face arrire pleine
		glPolygonMode(GL_BACK,GL_FILL);
	}

	//********** on dsactive tout **********
	//dsactivation des tableaux de coordonne de vertices
	glDisableClientState(GL_VERTEX_ARRAY);
	//dsactivation culling
	glDisable(GL_CULL_FACE);
	glEnable(GL_TEXTURE_2D);

}