// Joueur.cpp: implementation of the Joueur class.
//
//////////////////////////////////////////////////////////////////////

#include "Joueur.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Joueur::Joueur()
{
	// charge le model du joueur
	this->model = new Model();
	model->load("./ressources/models/arme.obj");

	// initialide le joueur pour qu'il ne tir pas au depart.
	this->beginFireTime = 0;
	this->currentFireDisplayTime = 0;
	this->beginFireTime = 0;
	this->displayFireTime = 0;
}

Joueur::~Joueur()
{
	// supprime la memoire aloue dynamiquement
	delete [] this->model;
	delete fireTexture;
	delete crosshair;
}

void Joueur::draw(bool onlyToon)
{
	// on sauvegarde la matrice de modelView courante
	glPushMatrix();
		glPushMatrix();
			glRotatef(180,0,1,0);
			glTranslatef(3,-15,2);// le bon
			float matrice[16];
			glGetFloatv(GL_MODELVIEW_MATRIX, matrice);
		glPopMatrix();
		// puis on nettoie la matrice courante pour toujours afficher l'arme en face de la camera.
		glLoadIdentity();
		
		// on place l'arme
		glRotatef(180,0,1,0);
		// et on l'affiche
		if (this->isShooting())
		{
			// avec un leger decalage quand on tir.
			glColor3f(1,0.3,0.3);
			glTranslatef(3,-15,1);// le bon
		}
		else
		{
			glTranslatef(3,-15,2);// le bon
		}

		
		// on ajoute le translation precedente a la matrice
		RULES_Vector right;
		right.setCoord(matrice[0],matrice[4],matrice[8]);
		RULES_Vector up;
		up.setCoord(matrice[1],matrice[5],matrice[9]);
		RULES_Vector dir;
		dir.setCoord(matrice[2],matrice[6],matrice[10]);

		//Hmmm!?
		// calcule la nouvelle position de l'arme ???
		RULES_Vector aPos=this->pos;
		aPos.setOneCoord(0,aPos.getX()+ right.getX()*3 + right.getY()*3 + right.getZ()*3);
		aPos.setOneCoord(1,aPos.getY()+ up.getX()*(-15) + up.getY()*(-15) + up.getZ()*(-15));
		aPos.setOneCoord(2,aPos.getZ()+ dir.getX()*2 + dir.getY()*2 + dir.getZ()*2);

		// TODO revoir ca, ca ne marche pas bien, il suffit de regarder la gestion de la lumiere lorsqu'on regarde
		// vers la haut ou vers le bas
		// on calcule la nouvelle position de la lumiere sur l'arme.
		RULES_Vector lightPos;
		lightPos.setCoord(light->getX() - aPos.getX(),light->getY() - aPos.getY(),light->getZ() - aPos.getZ());

		// on projete la lumiere dans la matrice de l'arme
		RULES_Vector temp;
		temp.setOneCoord(0,lightPos.dot3(&right));
		temp.setOneCoord(1,lightPos.dot3(&up));
		temp.setOneCoord(2,lightPos.dot3(&dir));


		if(onlyToon)
		{
			// on ne veut afficher que le toon
			this->modelDrawer->drawToonOnly(this->model,temp,false);
			glColor3f(1,1,1);
		}
		else
		{
			// on affiche le model
			glColor3f(1,1,1);
			this->modelDrawer->draw(this->model,temp);
		}
		
		
		// on active l'alpha test pour le feu de l'arme
		glEnable(GL_ALPHA_TEST);
		glEnable(GL_BLEND);
		glColor4f(1,1,1,1);
		glAlphaFunc(GL_GREATER,0.f);
		if (this->isShooting())
		{
			// on est en train de tirer
			this->currentFireDisplayTime = glutGet(GLUT_ELAPSED_TIME);
			// on se bind sur la texture de tir
			glBindTexture(GL_TEXTURE_2D, this->fireTexture->getId());
			// on effectue la rotation de texture
			glMatrixMode(GL_TEXTURE);
			// on sauvegarde la matrice courante de texture
			glPushMatrix();
				// on nettoie la matrice de texture
				glLoadIdentity();
				// on effectue un premiere translationpour la mettre en 0,0
				glTranslatef(0.5,0.5,0);
				// on effectue la rotation
				glRotatef(this->textureRotation,0,0,1);
				// puis on reefectue une translation pour remettre la texture a le bonne place
				glTranslatef(-0.5,-0.5,0);
				// on se remet en modelView
				glMatrixMode(GL_MODELVIEW);
				// on place le quad qui servira  afficher la texture de tir
				glTranslatef(0,7,17);
				float size = 10;

				// on dessine le quad avec la texture de tir.
				glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
				glDepthMask(GL_FALSE);
				glBegin(GL_QUADS);
					glTexCoord2f(0,1);
					glVertex2f(-size,size);
					glTexCoord2f(0,0);
					glVertex2f(-size,-size);
					glTexCoord2f(1,0);
					glVertex2f(size,-size);
					glTexCoord2f(1,1);
					glVertex2f(size,size);
				glEnd();
				// on repasse en mode matrice de texture pour charger la matrice saugegard precedament
				glMatrixMode(GL_TEXTURE);
			// on recharge la matrice de texture sauv precedament
			glPopMatrix();
			// on affiche l'autre partie de feu
			glDepthMask(GL_TRUE);
			// et on repasse en mode modelView
			glMatrixMode(GL_MODELVIEW);
		}
		
		// on affiche le viseur et le score
		// on desactive le depth test
		glDisable(GL_DEPTH_TEST);
		
		// on passe en mode projection
		glMatrixMode(GL_PROJECTION);
		
		// on sauvegarde la matrice de projection
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			// on passe en mode ortho de la taille de l'ecran
			glOrtho(0,screenWidth,0,screenHeight,-1,1);	
			
			// on passe en mode modelview
			glMatrixMode(GL_MODELVIEW);
			
			// on sauvegarde la matrice de modelview
			glPushMatrix();
			
				// on nettoie la matrice de projection
				glLoadIdentity();
				
				// on dessine le crosshair
				glBlendFunc(GL_ONE_MINUS_SRC_ALPHA,GL_SRC_ALPHA);
				glBindTexture(GL_TEXTURE_2D,this->crosshair->getId());
				glBegin(GL_QUADS);
					glTexCoord2f(0,0);
					glVertex2f(screenWidth/2.0f - 15,screenHeight/2.0f - 15);
					glTexCoord2f(1,0);
					glVertex2f(screenWidth/2.0f + 17,screenHeight/2.0f - 15);
					glTexCoord2f(1,1);
					glVertex2f(screenWidth/2.0f + 17,screenHeight/2.0f + 17);
					glTexCoord2f(0,1);
					glVertex2f(screenWidth/2.0f - 15,screenHeight/2.0f + 17);
				glEnd();
				// on selectionne la matrice de projection
				glMatrixMode(GL_PROJECTION);
			
			// et on recupere la matrice de projection sauvegard precedement
			glPopMatrix();	
			
			// on selectionne la matrice de projection modelview
			glMatrixMode(GL_MODELVIEW);
		
		// et on recupere la matrice de modelview sauvegard precedement
		glPopMatrix();
		
		// puis on reactive le depth test
		glEnable(GL_DEPTH_TEST);

		// et on desactive le test alpha.....
		glDisable(GL_ALPHA_TEST);
		glDisable(GL_BLEND);
	glPopMatrix();
}

void Joueur::setCurrentFireDisplayTime(int time)
{
	this->currentFireDisplayTime = time;
}

void Joueur::setFireTexture(RULES_Texture * tex)
{
	this->fireTexture = tex;
}

void Joueur::setDisplayFireTime(int time)
{
	this->displayFireTime = time;
}

void Joueur::setShootFrequency(int frequency)
{
	this->shootFrequency = frequency;
}

void Joueur::setScore(int aScore)
{
	this->score = aScore;
}

void Joueur::setSpeed(float aSpeed)
{
	this->speed = aSpeed;
}

void Joueur::setIsWalking(bool isWalking)
{
	this->walking = isWalking;
}

void Joueur::setDirection(RULES_Vector direc)
{
	this->direction = direc;
}

int Joueur::getCurrentFireDisplayTime()
{
	return this->currentFireDisplayTime;
}

RULES_Texture * Joueur::getFireTexture()
{
	return this->fireTexture;
}

int Joueur::getDisplayFireTime()
{
	return this->displayFireTime;
}

int Joueur::getShootFrequency()
{
	return this->shootFrequency;
}

int Joueur::getScore()
{
	return this->score;
}

float Joueur::getSpeed()
{
	return this->speed;
}

bool Joueur::isWalking()
{
	return this->walking;
}

RULES_Vector Joueur::getDirection()
{
	return this->direction;
}

bool Joueur::isShooting()
{
	return (this->currentFireDisplayTime <= (this->beginFireTime + this->displayFireTime));
}

void Joueur::shoot()
{
	int temp = glutGet(GLUT_ELAPSED_TIME);
	// le joueur peut il tirer ?
	if( temp > this->beginFireTime + this->shootFrequency)
	{
		// il peut.
		this->beginFireTime = temp;
		//this->textureRotation += 10;
		this->textureRotation = sin((float)rand())*360;
		SoundManager::getInstance()->playDetonation();
	}
}

void Joueur::setCrossHairTex(RULES_Texture * tex)
{
	this->crosshair = tex;
}

void Joueur::setScreenAttributs(int width, int height)
{
	this->screenHeight = height;
	this->screenWidth = width;
}

void Joueur::setPosition(RULES_Vector pos)
{
	this->pos = pos;
}

RULES_Vector Joueur::getPosition()
{
	return this->pos;
}

RULES_Vector * Joueur::getLight()
{
	return this->light;
}

void Joueur::setLight(RULES_Vector *lightpos)
{
	this->light = lightpos;
}

