// MotionBlur.h: interface for the MotionBlur class.
//
//////////////////////////////////////////////////////////////////////

#ifndef MOTIONBLUR_H
#define MOTIONBLUR_H

#ifdef WIN32
#include <windows.h>
#endif
#include <GL/gl.h>
#include <GL/glut.h>
#include <GL/glext.h>
#include <stdio.h>
#include "stdlib.h"
#include <iostream>
#include <math.h>

/**
* Class permettant d'appliquer un effet de BLUR radial  la scne
*/
class MotionBlur  
{
private:

	/**
	* La prsence du blur dans l'image final(dpend du temps couler)
	*/
	float multiplicateur;

	/**
	*  Permet de crer une texture vide pour calculer le blur
	*
	* @param size la taille en texel de la texture
	* @param channels le nom de canal de la texture (GL_RGB comseill)
	* @param type le type de donne de la texture
	*
	* BUG FIXME : type ne devrait pas tre un paramtre de la fonction : le tableau est allou dedans et le type est toujour le mme!!!
	*/
	void createRenderTexture(int size, int channels, int type);

	/**
	* l'identifiant de la texture servant  blur la scene
	*/
	unsigned int textureID;

	/**
	* le facteur radial du blur. Plus il est lever, plus l'effet de dcalage est important.
	*/
	float factor;

public:

	/**
	* Permet de dsactiver le blur mme si celui-ci est rendu
	*
	* REM : il faut viter de rendre le BLUR lorsque celuici est dsactiver : On consommerait du fillrate pour rien!
	*/
	void stop();

	/**
	* Permet d'activ l'effet de blur
	*/
	void start();

	/**
	*	Permet de rendre l'effet de blur  l'cran par dessus la scne prsente.
	* Le blur est rendu correctement suivant le temp couler avec les bon facteur.
	*/
	void draw();

	/**
	* Calcule les facteurs de blur suivant le temps couler depuis la dernire image.
	*
	* @param float le temp couler depuis la dernire image en millisecond
	*/
	void calcFactor(float elapsedTime);

	/**
	* Le constructeur
	*/
	MotionBlur();

	/**
	* Le destructeur
	*/
	virtual ~MotionBlur();

};

#endif 
