// Mouse.cpp: implementation of the Mouse class.
//
//////////////////////////////////////////////////////////////////////

#include "Mouse.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Mouse::Mouse()
{
	image = new RULES_Texture();
	image->loadBMP("./ressources/textures/mouse.bmp",0,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
}

Mouse::~Mouse()
{
	if(image != NULL)
	{
		delete image;
		image = NULL;
	}
}

void Mouse::draw(RULES_Vector * pos)
{
	glDisable(GL_DEPTH_TEST);
	// on passe en mode projection
	glMatrixMode(GL_PROJECTION);
		
				// on sauvegarde la matrice de projection
	glPushMatrix();
	
		// on nettoie la matrice de projection
		glLoadIdentity();
		
		// on passe en mode ortho de la taille de l'ecran
		glOrtho(0,1024,0,768,-1,1);	
		
		// on passe en mode modelview
		glMatrixMode(GL_MODELVIEW);
		
		// on sauvegarde la matrice de modelview
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			// on active l'alpha test et la blending
			// NOTE: sur les cartes Nvidia, on peut activer seulement l'alpha test, mais sur les cartes
			// ATI, on est oblig d'avoir le blending d'activ si on veut que l'alpha test fonctionne.
			glEnable(GL_ALPHA_TEST);
			glEnable(GL_BLEND);
			glBlendFunc(GL_ONE_MINUS_SRC_ALPHA,GL_SRC_ALPHA);
			glColor4f(1,1,1,1);
			glAlphaFunc(GL_GREATER,0.f);
			// on selsctionne la texture du curseur
			glBindTexture(GL_TEXTURE_2D,this->image->getId());
			// on affiche l quad de la souris.
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(pos->getX(), pos->getY());
				glTexCoord2f(0,0);
				glVertex2f(pos->getX(), pos->getY()-32);
				glTexCoord2f(1,0);
				glVertex2f(pos->getX()+32, pos->getY()-32);
				glTexCoord2f(1,1);
				glVertex2f(pos->getX()+32, pos->getY());
			glEnd();
			glDisable(GL_ALPHA_TEST);
			glDisable(GL_BLEND);

			glMatrixMode(GL_PROJECTION);
		
		// et on recupere la matrice de projection sauvegard precedement
		glPopMatrix();	
		
		// on selectionne la matrice de projection modelview
		glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	// on desactive le depth test
	glEnable(GL_DEPTH_TEST);

}
