// OptionMenu.h: interface for the OptionMenu class.
//
//////////////////////////////////////////////////////////////////////

#ifndef OPTIONMENU_H
#define OPTIONMENU_H

#include "Menu.h"
#include "MainMenu.h"
#include "Bouton.h"
#include "SonsMenu.h"
#include "GameMenu.h"
#include "VideoMenu.h"

/**
 * classe gerant le menu des options (son, jeu, video).
 *
 * pour plus de renseignement sur les methode de cette classe, voir la classe GLUT
 */
class OptionMenu : public Menu  
{
private:
	int mouseX,mouseY;
	
	Bouton * retour;
	Bouton * video;
	Bouton * son;
	Bouton * jeu;
	
	OptionMenu();

public:
	virtual ~OptionMenu();
	void draw(void);

	void idle(void);

	void mouseClicked(int boutton,int etat,int x,int y);
	void mouseMoved(int x,int y);
	void mouseMovedClicked(int x,int y);

	void keyPressed(unsigned char key,int x,int y);
	void keyReleased(unsigned char key,int x,int y);
	void specialKeyFunc(int key,int x,int y){};
	void specialKeyUpFunc(int key,int x,int y){};

	void reshape(int largeur,int hauteur);
	static OptionMenu * getInstance(){static OptionMenu instance;return &instance;};

};

#endif 