//			RULES_Vector
//						programm par Hillaire Sbastien & Michel De Verdelhan
//						dernire mise  jour : 16/09/2003


#ifndef RULES_VECTOR
#define RULES_VECTOR

#ifndef PI
#define PI			3.1415926
#endif

/**
* Une classe reprsentant un vecteur  trois composantes
*/
class RULES_Vector
{
private:
	/**
	* Le tableau de coordonne du vecteur
	*/ 
	float coord[3];

public:
	/**
	* Permet d'affecter une coordone du vecteur
	*
	* @param xyz le numro de la coordone
	* @param val la valeur  insrer
	*/
	void setOneCoord(unsigned int xyz,float val);

	/**
	* Effectue le produit vectoriel entre this et v (dans cette ordre!)
	*
	* @param v le vecteur  utilis pour le produit
	* @param le vecteur rultant est plac dans dir (prcedement allouer)
	*/
	void prodVectoriel(RULES_Vector *v,RULES_Vector *dir);

	/**
	* Permet de faire tourner le vecteur sur un des axe spcifier
	*
	* @param rad l'angle en radiant
	* @param x autour de l'axe x?
	* @param y autour de l'axe y?
	* @param z autour de l'axe z?
	*/
	void rotate(float rad,bool x,bool y,bool z);

	/**
	* Effectue la translation du vecteur par t
	*
	* @param t le vecteur de translation
	*/
	void translate(float* t);

	/**
	* Retourne un pointeur sur le tableau de float du vecteur
	* REM : DEVRAIT ETRE CONST!!!
	*
	* @return le pointeur sur les 3 coordonnes
	*/
	float* getCoord();

	/**
	* retourne la valeur d'une composante
	*
	* @param composante le numro de la composante  retourn
	* @return la valeur de la composante demande
	*/
	float getCoord(int composante);

	/**
	* retourne la composante x du vecteur
	*
	* @return x
	*/
	float getX();

	/**
	* retourne la composante y du vecteur
	*
	* @return y
	*/
	float getY();

	/**
	* retourne la composante z du vecteur
	*
	* @return z
	*/
	float getZ();

	/**
	* Effectue le produit scalair entre this et v
	*
	* @param le vecteur utilis pour le produit
	* @return la valeur du produit scalaire
	*/
	float dot3(RULES_Vector* v);

	/**
	* Normalise le vecteur  une taille de 1
	*/
	void normalisation();

	/**
	* Pour obtnir la longueur du vecteur
	*
	* @return la longueur
	*/
	float length();

	/**
	* Copie la valeur du tableau c dans le tableau de composante
	*
	* @param c un pointeur sur un tableau d'au moins 3 float
	*/
	void setCoord(const float* c);

	/**
	* Affecte les 3 composante du vecteur
	*
	* @param nouvelle valeur de x
	* @param nouvelle valeur de y
	* @param nouvelle valeur de z
	*/
	void setCoord(float x,float y,float z);

	/**
	* constructeur
	*/
	RULES_Vector();

	/**
	* Destructeur
	*/
	~RULES_Vector();

	/**
	* oprateur surcharg
	*/
	RULES_Vector& operator =(const RULES_Vector& v);
	/**
	* oprateur surcharg
	*/
	RULES_Vector& operator +=(const RULES_Vector& v);
	/**
	* oprateur surcharg
	*/
	RULES_Vector& operator -=(const RULES_Vector& v);
	/**
	* oprateur surcharg
	*/
	RULES_Vector& operator *=(const RULES_Vector& v);
	/**
	* oprateur surcharg
	*/
	RULES_Vector& operator /=(const RULES_Vector& v);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator +(const RULES_Vector& v);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator -(const RULES_Vector& v);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator *(const RULES_Vector& v);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator /(const RULES_Vector& v);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator +(float n);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator -(float n);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator *(float n);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator /(float n);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator +=(float n);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator -=(float n);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator *=(float n);
	/**
	* oprateur surcharg
	*/
	RULES_Vector operator /=(float n);
};

#endif
