// SkyBox.h: interface for the SkyBox class.
//
//////////////////////////////////////////////////////////////////////

#ifndef SKYBOX_H
#define SKYBOX_H

#ifdef WIN32
#include <windows.h>
#endif
#include <GL\gl.h>
#include <GL\glut.h>
#include <gl\glext.h> 
#include "RULES_Texture.h"

/**
* La classe permettant d'afficher une skybox pour donner un environnement gneral(et lointain) de jeu.
*/
class SkyBox  
{
public:
	/**
	* la texture arrire de la skybox
	*/
	RULES_Texture * back;
	/**
	* la texture avant de la skybox
	*/
	RULES_Texture * front;
	/**
	* la texture du bas de la skybox
	*/
	RULES_Texture * bottom;
	/**
	* la texture du haut de la skybox
	*/
	RULES_Texture * top;
	/**
	* la texture de la gauche de la skybox
	*/
	RULES_Texture * left;
	/**
	* la texture de la droite de la skybox
	*/
	RULES_Texture * right;

	/**
	* La hauteur de la skybox
	*/
	float height;
	/**
	* la largeur de la sky box
	*/
	float width;
	/**
	* la profondeur de la skybox
	*/
	float length;

	/**
	* Constructeur
	*/
	SkyBox();
	/**
	* Destructeur
	*/
	virtual ~SkyBox();

	/**
	* Affiche  l'cran la skybox
	*
	* @param x la position x du centre de la skybox
	* @param y la position y du centre de la skybox
	* @param z la position z du centre de la skybox
	*/
	void drawSkyBox(float x,float y,float z);

};

#endif
